/*
  jsFilterTxtReplace.  Written by Joe McCormack, 2009.  www.virtualsecrets.com.
*/
var substituteBlockLabel = "substituteBlock_";	/* ID prefix of checkbox that is dynamically created */
var filterContentSourceID = "contentToChange";	/* ID of DIV element to get content from */
var filterTagMatchIE = "<B>change</B>";		/* The text sequence to change for IE */
var filterTagMatchFF = "<b>change</b>";		/* The text sequence to change for FF */
substituteBlockValues = new Array();		/* Contains the dynamically created checkboxes for reference */
var substituteBlockID = 0;			/* Counter value assigned to checkbox IDs */
var cPosIndex = -1;
var txtLastValue = "";
var substituteValueForBrowser = "";
cPos = new Array();
/* DOCTYPE DETECTION - Do Not Use */
var filterCaptureDocTypeFound = 0;		/* 1 = doctype definition found in page, 0 = not found */
var filterCaptureDoctypeLabel = "";		/* Output like: HTML */
var filterCaptureDoctypeType = "";		/* Output like: -//W3C//DTD XHTML 1.0 Transitional//EN */
var filterCaptureDoctypePath = "";		/* Output like: http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd */
function jsFilterCaptureDocTypeDefinition() {
if (navigator.userAgent.toLowerCase().indexOf("msie") > 0) {
							    for (x = 0; x < document.getElementsByTagName("!").length; x++) {
															     if (parseInt(document.getElementsByTagName("!")[x].nodeType) == 8) {
																								 if (document.getElementsByTagName("!")[x].nodeValue.toLowerCase().indexOf("doctype") > -1) {
																																			     tagData = new Array(); tagData = document.getElementsByTagName("!")[x].nodeValue.split("\"");
																																			     filterCaptureDoctypeLabel = tagData[0].replace("DOCTYPE ", "").toUpperCase(); filterCaptureDoctypeType = tagData[1]; filterCaptureDoctypePath = tagData[3]; filterCaptureDocTypeFound = 1;
																																			    }
																								}
															    }
							   }
else {
      /* All Other Browsers */
      for (x = 0; x < document.childNodes.length; x++) {
							if (parseInt(document.childNodes[x].nodeType) == 10) {
													      filterCaptureDoctypeLabel = document.childNodes[x].name.toUpperCase();
													      filterCaptureDoctypeType = document.childNodes[x].publicId;
													      filterCaptureDoctypePath = document.childNodes[x].systemId;
													      filterCaptureDocTypeFound = 1;
													     }
						       }
     }
}
function jsFilterCreateElement(pType, id, name) {
/* Create Page Elements */
var pageElementChild;
pageElementChild = document.createElement(pType);
pageElementChild.setAttribute("id", id);
pageElementChild.setAttribute("name", name);
if (filterCaptureDocTypeFound == 1) {
				     try { document.documentElement.appendChild(pageElementChild, null); }
				     catch (onerror) { document.documentElement.appendChild.add(pageElementChild); }
				    }
else {
      try { document.body.appendChild(pageElementChild, null); }
      catch (onerror) { document.body.appendChild.add(pageElementChild); }
     }
}
function jsFilterTxtFind(targetTxtField, matchTxt) {
if (matchTxt.length > 0) {
			  if (txtLastValue != matchTxt) { cPos = []; cPosIndex = -1; txtLastValue = matchTxt; }
			  if (cPosIndex == -1) { jsFilterTxtIndexMatches(targetTxtField, matchTxt); }
			  else { jsFilterTxtMatchReplace(targetTxtField, matchTxt); }
			 }
}
function jsFilterTxtIndexMatches(targetTxtField, matchTxt) {
tmpArray = new Array(); tmpArray2 = new Array();
try {
     var inputString = matchTxt;
     tmpArray = document.getElementById(targetTxtField).value.match(new RegExp(inputString, "gi"));
     var handleData = document.getElementById(targetTxtField).value;
     for (x = 0; x < tmpArray.length; x++) {
					    tmpArray2[tmpArray2.length] = handleData.indexOf(inputString);
					    handleData = handleData.substr(tmpArray2[tmpArray2.length - 1] + inputString.length, handleData.length);
					    if (x == 0) { cPos[cPos.length] = tmpArray2[x]; }
					    else { cPos[cPos.length] = cPos[cPos.length - 1] + tmpArray2[x] + inputString.length; }
					   }
     if (cPos.length > 0) {
			   /* Replace first or only match */
			   cPosIndex = 0;
			   jsFilterTxtMatchReplace(targetTxtField, matchTxt);
			  }
    }
catch (onerror) { /* No string match */ }
}
function jsFilterTxtMatchReplace(targetTxtField, matchTxt) {
substituteBlockID = substituteBlockID + 1;
var substituteBlock = "<input type=\"checkbox\" id=\"" + substituteBlockLabel + substituteBlockID + "\" onclick=\"filterClickTrack();\" />";
substituteBlockValues[substituteBlockValues.length] = substituteBlock;
var inputString = matchTxt;
var oRange; var iStart = 0, iEnd = 0;
if (cPosIndex > cPos.length - 1) { cPosIndex = 0; }
iStart = cPos[cPosIndex]; iEnd = cPos[cPosIndex] + inputString.length; cPosIndex = cPosIndex + 1;
if (navigator.userAgent.toLowerCase().indexOf("msie") > -1) {
							     oRange = document.getElementById(targetTxtField).createTextRange();
							     oRange.moveStart("character", iStart); oRange.moveEnd("character", iEnd);
							     oRange.select(); oRange.collapse(true);
							     oRange.text = substituteBlock;
							     document.getElementById(targetTxtField).value = document.getElementById(targetTxtField).value.substring(0, (iStart + substituteBlock.length)) + document.getElementById(targetTxtField).value.substring((iStart + substituteBlock.length + matchTxt.length), document.getElementById(targetTxtField).value.length);
							    }
else {
      document.getElementById(targetTxtField).setSelectionRange(iStart, iEnd);
      var ffStart = document.getElementById(targetTxtField).selectionStart;
      document.getElementById(targetTxtField).value = document.getElementById(targetTxtField).value.substring(0, ffStart) + substituteBlock + document.getElementById(targetTxtField).value.substring(document.getElementById(targetTxtField).selectionEnd, document.getElementById(targetTxtField).value.length);
     }
}
function filterClickTrack() {
var validated = 0;
if (document.getElementById(filterContentSourceID).innerHTML.indexOf(substituteBlockLabel) > -1) {
												  var qclicks = 0;
												  for (q = 1; q <= substituteBlockID; q++) {
																	    var qtarget = substituteBlockLabel + q;
																	    if (document.getElementById(qtarget).checked == true) { qclicks = qclicks + 1; }
																	   }
												  if (qclicks == substituteBlockID) { validated = 1; } else { validated = 0; }
												 }
else { validated = 2; }
if (validated == 0) { alert("All dynamically created checkboxes have NOT been checked yet."); }
else if (validated == 1) { alert("All dynamically created checkboxes HAVE been checked."); }
else { alert("No dynamically created checkboxes were found."); }
}
function jsFilterStart() {
if (document.getElementById("initWorkOriginal")) { alert("The content has already been changed."); }
else {
      jsFilterCaptureDocTypeDefinition();
      jsFilterCreateElement("div", "initWorkOriginal", "initWorkOriginal");
      jsFilterCreateElement("textarea", "initFilterWork", "initFilterWork");
      if (document.getElementById("initWorkOriginal")) {
							document.getElementById("initWorkOriginal").style.display = "none";
							document.getElementById("initFilterWork").style.visibility = "hidden";
							document.getElementById("initWorkOriginal").innerHTML = document.getElementById(filterContentSourceID).innerHTML;
							document.getElementById("initFilterWork").value = document.getElementById(filterContentSourceID).innerHTML;
							if (navigator.userAgent.toLowerCase().indexOf("msie") > -1) { substituteValueForBrowser = filterTagMatchIE; }
							else { substituteValueForBrowser = filterTagMatchFF; }
							jsFilterTxtFind("initFilterWork", substituteValueForBrowser);
							var initialCount = cPos.length;
							if (initialCount > 1) {
									       for (z = 2; z <= initialCount; z++) {
														    cPos = []; cPosIndex = -1; txtLastValue = "";
														    jsFilterTxtFind("initFilterWork", substituteValueForBrowser);
														   }
									      }
							document.getElementById(filterContentSourceID).innerHTML = document.getElementById("initFilterWork").value;
						       }
      else { alert("Element could not be created."); }
     }
}
function jsFilterShow() {
if (substituteBlockValues.length > 0) {
				       var compiled = "";
				       for (y = 0; y < substituteBlockValues.length; y++) { compiled = compiled + "(" + y + ") " + substituteBlockValues[y] + "\n"; }
				       compiled = "DYNAMICALLY GENERATED CODE BLOCKS INSERTED:\n\n" + compiled;
				       alert(compiled);
				      }
else { alert("No substituted code blocks were found."); }
}
function jsFilterRestore() {
if (document.getElementById("initWorkOriginal").innerHTML.length > 0) { document.getElementById(filterContentSourceID).innerHTML = document.getElementById("initWorkOriginal").innerHTML; substituteBlockValues = []; }
else { alert("Content needs to be changed before it can be restored."); }
}
